/* $Id: bf533.c,v 0.1 2004/09/20 20:35:35 jrothwei Exp $ */

/* This code is based on the examples in the documentation for the 
** Analog Devices Blackfin BF533 EZ-KIT. These are subroutines
** to perform specific functions related to the Blackfin and EZ-KIT
** hardware.
*/

#include <cdefBF533.h>

//--------------------------------------------------------------------------//
// Symbolic constants														//
//--------------------------------------------------------------------------//
// addresses for Port B in Flash A
#define pFlashA_PortB_Dir	(volatile unsigned char *)0x20270007
#define pFlashA_PortB_Data	(volatile unsigned char *)0x20270005

/*Hstart*/ void bf533_flashled_init(void)
/*Hend;*/ {
	*pEBIU_AMBCTL0	= 0x7bb07bb0;
	*pEBIU_AMBCTL1	= 0x7bb07bb0;
	*pEBIU_AMGCTL	= 0x000f;
	*pFlashA_PortB_Dir = 0x3f;
}
/*Hstart*/ void bf533_flashled(int pat)
/*Hend;*/ {
	*pFlashA_PortB_Data = pat&0x3f;
}
/*Hstart*/ void bf533_cyctimes_raw(unsigned int *t2)
/*Hend;*/ {
	asm("%0=CYCLES;%1=CYCLES2;":
	"=d"(t2[1]),"=d"(t2[0]));
}
/*Hstart*/ int bf533_sdram_configure(void) /* Returns 0 if already set up. */
/*Hend;*/ {
	short int schk;
	
	/* Check whether SDRAM is enabled already.  If so, exit.
	   If not, continue with configurations.  */
	
	schk = *pEBIU_SDSTAT;
	if((schk&0x8) == 0) return 0;

	/* Initalize SDRAM registers. */

	//SDRAM Refresh Rate Control Register
	*pEBIU_SDRRC = 0x0817;								

	//SDRAM Memory Bank Control Register
	*pEBIU_SDBCTL = 0x0013;

	//SDRAM Memory Global Control Register	
	*pEBIU_SDGCTL = 0x0091998d;
	
	return 1;
}
