/* $Id: misclib.c,v 0.1 2004/09/20 20:35:35 jrothwei Exp $ */
/* Copyright (C) 2004  Sensicomm LLC
** Joseph Rothweiler http://www.sensicomm.com
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* Routines for printing integer values in a human-readable format.
** For use when i/o is needed without the overhead of the full
** printf-family of subroutines.
*/

/*Hstart*/ void unsigned2str(unsigned val, unsigned char *str /*Length 16*/ )
/*Hend;*/ {
	char tstr[16];
	int i;
	
	for(i=0;i<16;i++) tstr[i] = 0;
	for(i=0;i<15;i++) {
		unsigned vv;
		if((i>0)&&(val==0)) break;
		vv=val%10;
		tstr[i]='0'+vv;
		val/=10;
	}
	if(i>=15) {
		*str++ = '*';
	} else {
		if(i<=0)i=1;
		for(i-- ; i>=0;i--) *str++ = tstr[i];
	}
	*str++='\0';
	return;
}
/*Hstart*/ unsigned char *unsigned2staticstr(unsigned val)
/*Hend;*/ {
	static unsigned char rtnstr[16];
	unsigned2str(val,rtnstr);
	return rtnstr;
}
static char hexconv[]="0123456789abcdef";
/*Hstart*/ void long2strhex(long val, char *str /* length 9 */)
/*Hend;*/ {
	int i;
	for(i=0;i<8;i++) str[i] = hexconv[(val>>(28-4*i))&0xf];
}
/*Hstart*/ char *long2staticstrhex(long val)
/*Hend;*/ {
	static char rtnval[9];
	long2strhex(val,rtnval);
	return rtnval;
}
